Name:           ppc64-diag
Version:        2.4.2
Release:        10%{?dist}
Summary:        Linux for Power Platform Diagnostics
URL:            http://sourceforge.net/projects/linux-diag/files/ppc64-diag/
Group:          System Environment/Base
License:        EPL
ExclusiveArch:  ppc ppc64
BuildRequires:  libservicelog-devel, flex, perl, byacc, librtas-devel
BuildRequires:  libvpd-devel
Requires:       servicelog, lsvpd
Requires (preun): /sbin/chkconfig
Requires (preun): /sbin/service
Requires (post): /sbin/chkconfig
Buildroot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Source0:        http://downloads.sourceforge.net/project/linux-diag/ppc64-diag/%{version}/%{name}-%{version}.tar.gz
Patch0:         ppc64-diag-2.4.2-messagecatalog-location.patch
Patch2:         ppc64-diag-2.4.2-init-location.patch
Patch3:         ppc64-diag-2.4.2-cflags-err.patch
Patch4:         ppc64-diag-2.4.2-field-alignment.patch
Patch5:         ppc64-diag-2.4.2-kernel-id.patch

%description
Platform diagnostics for Linux for Power writes events reported by the
System p or System i platform firmware to the service log, provides automated
responses to urgent events such as environmental conditions and predictive
failures, and provides notifications of the event to system administrators
or connected service frameworks.  Some error log analysis parameters can be
configured in /etc/ppc64-diag/ppc64-diag.config.

%prep
%setup -q
%patch0 -p1 -b .msg_loc
%patch2 -p1 -b .init-location
%patch3 -p1 -b .cflags-err
%patch4 -p1 -b .field-alig
%patch5 -p1 -b .kernel-id

%build
make CFLAGS="$RPM_OPT_FLAGS -DDEBUG -fPIE -pipe -Wextra -fno-strict-aliasing" %{?_smp_mflags}

%install
make install DESTDIR=$RPM_BUILD_ROOT
chmod 644 COPYRIGHT
rm -f $RPM_BUILD_ROOT/usr/share/doc/packages/ppc64-diag/COPYRIGHT
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr (-,root,root,-)
%doc COPYRIGHT
%dir %{_sysconfdir}/%{name}
%{_mandir}/man8/*
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/%{name}/ppc64-diag.config
%attr(755,root,root) %{_sbindir}/*
%dir %{_datadir}/%{name}
%dir %attr(755,root,root) %{_datadir}/%{name}/message_catalog/
%attr(755,root,root) %{_sysconfdir}/%{name}/ppc64_diag_migrate
%attr(755,root,root) %{_sysconfdir}/%{name}/ppc64_diag_mkrsrc
%attr(755,root,root) %{_sysconfdir}/%{name}/ppc64_diag_notify
%attr(755,root,root) %{_sysconfdir}/%{name}/ppc64_diag_servagent
%attr(755,root,root) %{_sysconfdir}/%{name}/ppc64_diag_setup
%attr(644,root,root) %{_sysconfdir}/%{name}/servevent_parse.pl
%attr(644,root,root) %{_datadir}/%{name}/message_catalog/cxgb3
%attr(644,root,root) %{_datadir}/%{name}/message_catalog/e1000e
%attr(644,root,root) %{_datadir}/%{name}/message_catalog/exceptions
%attr(644,root,root) %{_datadir}/%{name}/message_catalog/gpfs
%attr(644,root,root) %{_datadir}/%{name}/message_catalog/reporters
%attr(644,root,root) %{_datadir}/%{name}/message_catalog/with_regex/*
%attr(755,root,root) %{_sysconfdir}/rc.powerfail
%attr(755,root,root) %{_sysconfdir}/rc.d/init.d/rtas_errd

%post
# Post-install script --------------------------------------------------
%{_sysconfdir}/%{name}/ppc64_diag_setup --register >/dev/null
/sbin/chkconfig --add rtas_errd

if [ "$1" = "2" ]; then # upgrade
    %{_sysconfdir}/rc.d/init.d/rtas_errd restart
fi

%preun
# Pre-uninstall script -------------------------------------------------
if [ "$1" = "0" ]; then # last uninstall
    %{_sysconfdir}/rc.d/init.d/rtas_errd stop >/dev/null 2>&1
    /sbin/chkconfig --del rtas_errd
    %{_sysconfdir}/%{name}/ppc64_diag_setup --unregister >/dev/null
fi

%triggerin -- librtas
# trigger on librtas upgrades ------------------------------------------
if [ "$2" = "2" ]; then
    %{_sysconfdir}/rc.d/init.d/rtas_errd restart
fi


%changelog
* Fri May 04 2012 Lukas Nykryn <lnykryn@redhat.com> 2.4.2-10
- Resolves: #818441 - rtas_errd does not automatically start

* Thu Apr 19 2012 Lukas Nykryn <lnykryn@redhat.com> 2.4.2-9
- Resolves: #814170 - ppc64-diag: "Kernel ID: " field is always "0"

* Tue Apr 17 2012 Lukas Nykryn <lnykryn@redhat.com> 2.4.2-8
- Resolves: #805048 - Discard output of rtas_errd stop
- Resolves: #812103 - Compile with -DDEBUG option

* Wed Feb 15 2012 Jiri Skala <jskala@redhat.com> 2.4.2-7
- Resolves: #632735 - New PAckage: ppc64-diag - added no-strict-aliasing

* Wed Feb 15 2012 Jiri Skala <jskala@redhat.com> 2.4.2-6
- Resolves: #632735 - New PAckage: ppc64-diag - adds correct cflags

* Mon Feb 13 2012 Jiri Skala <jskala@redhat.com> 2.4.2-5
- Resolves: #632735 - New Package: ppc64-diag-2.3.4+ - initial RHEL version, based on IBM spec file

* Thu Sep 22 2011 Karsten Hopp <karsten@redhat.com> 2.4.2-4
- fix preun and post install scriptlets

* Fri Sep 09 2011 Karsten Hopp <karsten@redhat.com> 2.4.2-3
- add buildrequirement systemd-units for _unitdir rpm macro
- move helper scripts to libexecdir/ppc64-diag

* Wed Sep 07 2011 Karsten Hopp <karsten@redhat.com> 2.4.2-2       
- additional fixes for Fedora package review (bugzilla #736062)

* Wed Aug 17 2011 Karsten Hopp <karsten@redhat.com> 2.4.2-1
- initial Fedora version, based on IBM spec file with rpmlint cleanups
  - move scripts to /usr/share/ppc-diag
  - don't start service automatically after install
